function GetThrowdowned_OnLoad()
	GetThrowdownedFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	-- Slash Commands
	SlashCmdList["GetThrowdowned"] = GetThrowdowned_SlashCommands
	SLASH_GetThrowdowned1 = "/gt"
	SLASH_GetThrowdowned2 = "/getthrowdowned"
end

-- Default Settings
if GT_Party == nil then
	GT_Party = true
end
if GT_Raid == nil then
	GT_Raid = true
end
if GT_PartyInstance == nil then
	GT_PartyInstance = true
end
if GT_RaidInstance == nil then
	GT_RaidInstance = true
end
if GT_Arena == nil then
	GT_Arena = true
end
if GT_Battleground == nil then
	GT_Battleground = true
end
if GT_HideServerName == nil then
	GT_HideServerName = true
end

-- Message Format
local MessageFormat = "%s %s %s."

-- Channels
local BattlegroundChannel		= "PARTY"
local ArenaChannel				= "PARTY"
local RaidInstanceChannel		= "PARTY"
local PartyInstanceChannel		= "PARTY"
local RaidChannel				= "PARTY"
local PartyChannel				= "PARTY"

function GetThrowdowned_OnEvent(self, event, ...)
	if select(4, GetBuildInfo()) >= 40200 then
		eventType, sourceGUID, destName, id = select(2, ...), select(4, ...), select(9, ...), select(12, ...)
	elseif select(4, GetBuildInfo()) >= 40100 then
		eventType, sourceGUID, destName, id = select(2, ...), select(4, ...), select(8, ...), select(10, ...)
	elseif select(4, GetBuildInfo()) >= 40000 then
		eventType, sourceGUID, destName, id = select(2, ...), select(3, ...), select(7, ...), select(9, ...)
	elseif select(4, GetBuildInfo()) >= 20400 then
		eventType, sourceGUID, destName, id = select(2, ...), select(3, ...), select(7, ...), select(9, ...)
	end

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if select(2, IsInInstance()) == "pvp" then
			if GT_Battleground == true then
				if GetRealNumPartyMembers() > 0 and GetRealNumPartyMembers() ~= 0 and GetRealNumPartyMembers() ~= nil then
					if eventType == "SPELL_AURA_APPLIED" then
						if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
								if string.find(destName,"-") and GT_HideServerName ~= false then
									destName = tostring(string.match(destName, "(.+)-"))
								end
							end
							local Message = format(MessageFormat, GetSpellLink(id), GT_UsedOn, destName)
							SendChatMessage(Message, BattlegroundChannel)
						end
					elseif eventType == "SPELL_AURA_REMOVED" then
						if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
								if string.find(destName,"-") and GT_HideServerName ~= false then
									destName = tostring(string.match(destName, "(.+)-"))
								end
							end
							local Message = format(MessageFormat, GetSpellLink(id), GT_FadedFrom, destName)
							SendChatMessage(Message, BattlegroundChannel)
						end
					end
				end
			end
		elseif select(2, IsInInstance()) == "arena" then
			if GT_Arena == true then
				if eventType == "SPELL_AURA_APPLIED" then
					if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
						if string.find(destName,"-") and GT_HideServerName ~= false then
							destName = tostring(string.match(destName, "(.+)-"))
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
							end
						end
						local Message = format(MessageFormat, GetSpellLink(id), GT_UsedOn, destName)
						SendChatMessage(Message, ArenaChannel)
					end
				elseif eventType == "SPELL_AURA_REMOVED" then
					if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
						if string.find(destName,"-") and GT_HideServerName ~= false then
							destName = tostring(string.match(destName, "(.+)-"))
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
							end
						end
						local Message = format(MessageFormat, GetSpellLink(id), GT_FadedFrom, destName)
						SendChatMessage(Message, ArenaChannel)
					end
				end
			end
		elseif select(2, IsInInstance()) == "raid" then
			if GT_RaidInstance == true then
				if eventType == "SPELL_AURA_APPLIED" then
					if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
						if string.find(destName,"-") and GT_HideServerName ~= false then
							destName = tostring(string.match(destName, "(.+)-"))
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
							end
						end
						local Message = format(MessageFormat, GetSpellLink(id), GT_UsedOn, destName)
						SendChatMessage(Message, RaidInstanceChannel)
					end
				elseif eventType == "SPELL_AURA_REMOVED" then
					if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
						if string.find(destName,"-") and GT_HideServerName ~= false then
							destName = tostring(string.match(destName, "(.+)-"))
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
							end
						end
						local Message = format(MessageFormat, GetSpellLink(id), GT_FadedFrom, destName)
						SendChatMessage(Message, RaidInstanceChannel)
					end
				end
			end
		elseif select(2, IsInInstance()) == "party" then
			if GT_PartyInstance == true then
				if eventType == "SPELL_AURA_APPLIED" then
					if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
						if string.find(destName,"-") and GT_HideServerName ~= false then
							destName = tostring(string.match(destName, "(.+)-"))
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
							end
						end
						local Message = format(MessageFormat, GetSpellLink(id), GT_UsedOn, destName)
						SendChatMessage(Message, PartyInstanceChannel)
					end
				elseif eventType == "SPELL_AURA_REMOVED" then
					if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
						if string.find(destName,"-") and GT_HideServerName ~= false then
							destName = tostring(string.match(destName, "(.+)-"))
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
							end
						end
						local Message = format(MessageFormat, GetSpellLink(id), GT_FadedFrom, destName)
						SendChatMessage(Message, PartyInstanceChannel)
					end
				end
			end
		elseif GetNumRaidMembers() > 0 and GetNumRaidMembers() ~= 0 and GetNumRaidMembers() ~= nil then
			if GT_Raid == true then
				if eventType == "SPELL_AURA_APPLIED" then
					if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
						if string.find(destName,"-") and GT_HideServerName ~= false then
							destName = tostring(string.match(destName, "(.+)-"))
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
							end
						end
						local Message = format(MessageFormat, GetSpellLink(id), GT_UsedOn, destName)
						SendChatMessage(Message, RaidChannel)
					end
				elseif eventType == "SPELL_AURA_REMOVED" then
					if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
						if string.find(destName,"-") and GT_HideServerName ~= false then
							destName = tostring(string.match(destName, "(.+)-"))
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
							end
						end
						local Message = format(MessageFormat, GetSpellLink(id), GT_FadedFrom, destName)
						SendChatMessage(Message, RaidChannel)
					end
				end
			end
		elseif GetNumPartyMembers() > 0 and GetNumPartyMembers() ~= 0 and GetNumPartyMembers() ~= nil then
			if GT_Party == true then
				if eventType == "SPELL_AURA_APPLIED" then
					if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
						if string.find(destName,"-") and GT_HideServerName ~= false then
							destName = tostring(string.match(destName, "(.+)-"))
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
							end
						end
						local Message = format(MessageFormat, GetSpellLink(id), GT_UsedOn, destName)
						SendChatMessage(Message, PartyChannel)
					end
				elseif eventType == "SPELL_AURA_REMOVED" then
					if id == 132168 and sourceGUID == UnitGUID("player") and destName ~= nil then
						if string.find(destName,"-") and GT_HideServerName ~= false then
							destName = tostring(string.match(destName, "(.+)-"))
							if string.find(destName,"-") and GT_HideServerName ~= false then
								destName = tostring(string.match(destName, "(.+)-"))
							end
						end
						local Message = format(MessageFormat, GetSpellLink(id), GT_FadedFrom, destName)
						SendChatMessage(Message, PartyChannel)
					end
				end
			end
		end
	end
end

function GetThrowdowned_SlashCommands(arg1)
	if arg1 == "" then
		GetThrowdowned_PrintSlashMenu()
	elseif arg1 == "party" then
		GT_Party = not GT_Party
		if GT_Party == true then
			print("|cFF50C0FF"..GT_Opt_Party..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GT_Opt_Party..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "raid" then
		GT_Raid = not GT_Raid
		if GT_Raid == true then
			print("|cFF50C0FF"..GT_Opt_Raid..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GT_Opt_Raid..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "partyinstance" or arg1 == "party instance" or arg1 == "partyi" then
		GT_PartyInstance = not GT_PartyInstance
		if GT_PartyInstance == true then
			print("|cFF50C0FF"..GT_Opt_PartyInstance..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GT_Opt_PartyInstance..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "raidinstance" or arg1 == "raid instance" or arg1 == "raidi" then
		GT_RaidInstance = not GT_RaidInstance
		if GT_RaidInstance == true then
			print("|cFF50C0FF"..GT_Opt_RaidInstance..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GT_Opt_RaidInstance..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "arena" then
		GT_Arena = not GT_Arena
		if GT_Arena == true then
			print("|cFF50C0FF"..GT_Opt_Arena..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GT_Opt_Arena..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "battleground" or arg1 == "bg" then
		GT_Battleground = not GT_Battleground
		if GT_Battleground == true then
			print("|cFF50C0FF"..GT_Opt_Battleground..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GT_Opt_Battleground..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "hideserver" or arg1 == "hide server" or arg1 == "hideservername" or arg1 == "hide servername" or arg1 == "hide server name" or arg1 == "hideserver name" then
		GT_HideServerName = not GT_HideServerName
		if GT_HideServerName == true then
			print("|cFF50C0FF"..GT_Opt_Solo..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GT_Opt_Solo..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
		end
	else
		GetThrowdowned_PrintSlashHelp()
	end
end

function GetThrowdowned_PrintSlashHelp()
	print("|cFFFFA500GetThrowdowned "..GetAddOnMetadata("GetThrowdowned", "Version").." "..GT_Opt_CmdList.."|cFFFFFFFF")
	print("|cFF50C0FF/gt - |cFFFFFFA0"..GT_Opt_HelpStatus.."|cFFFFFFFF")
	print("|cFF50C0FF/gt party - |cFFFFFFA0"..GT_Opt_HelpParty.."|cFFFFFFFF")
	print("|cFF50C0FF/gt raid - |cFFFFFFA0"..GT_Opt_HelpRaid.."|cFFFFFFFF")
	print("|cFF50C0FF/gt partyi - |cFFFFFFA0"..GT_Opt_HelpPartyInstance.."|cFFFFFFFF")
	print("|cFF50C0FF/gt raidi - |cFFFFFFA0"..GT_Opt_HelpRaidInstance.."|cFFFFFFFF")
	print("|cFF50C0FF/gt arena - |cFFFFFFA0"..GT_Opt_HelpArena.."|cFFFFFFFF")
	print("|cFF50C0FF/gt bg - |cFFFFFFA0"..GT_Opt_HelpBattleground.."|cFFFFFFFF")
	print("|cFF50C0FF/gt hideserver - |cFFFFFFA0"..GT_Opt_HelpHideServerName.."|cFFFFFFFF")
end

function GetThrowdowned_PrintSlashMenu()
	print("|cFFFFA500GetThrowdowned "..GetAddOnMetadata("GetThrowdowned", "Version").." "..GT_Opt_HelpInput.."|cFFFFFFFF")
	if GT_Party == true then
		print("|cFF50C0FF"..GT_Opt_Party..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GT_Opt_Party..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
	end
	if GT_Raid == true then
		print("|cFF50C0FF"..GT_Opt_Raid..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GT_Opt_Raid..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
	end
	if GT_PartyInstance == true then
		print("|cFF50C0FF"..GT_Opt_PartyInstance..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GT_Opt_PartyInstance..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
	end
	if GT_RaidInstance == true then
		print("|cFF50C0FF"..GT_Opt_RaidInstance..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GT_Opt_RaidInstance..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
	end
	if GT_Arena == true then
		print("|cFF50C0FF"..GT_Opt_Arena..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GT_Opt_Arena..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
	end
	if GT_Battleground == true then
		print("|cFF50C0FF"..GT_Opt_Battleground..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GT_Opt_Battleground..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
	end
	if GT_HideServerName == true then
		print("|cFF50C0FF"..GT_Opt_HideServerName..": |cFFADFF2F"..GT_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GT_Opt_HideServerName..": |cFFFF4500"..GT_Opt_Disable.."|cFFFFFFFF")
	end
end